package top.dreamcenter.go.client;

import top.dreamcenter.go.msg.Cross;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class Client {


    public static void main(String[] args) {

        try {
            Socket socket = new Socket("127.0.0.1", 1919);

            ObjectInputStream oi = new ObjectInputStream(socket.getInputStream());
            ObjectOutputStream os = new ObjectOutputStream(socket.getOutputStream());


            new MainFrame(oi, os);

        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    public static void sendMsg(ObjectOutputStream os, Object obj) {
        try {
            os.writeObject(obj);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static Object recMsg(ObjectInputStream oi){
        try {
            return oi.readObject();
        } catch (ClassNotFoundException | IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void printMap(Cross[][] map, Cross now){
        System.out.println();
        int width = map.length - 1;
        System.out.println("O A B C D E F G H I");
        for (int i = 0; i < map.length; i++) {
            System.out.print(i + 1 + " ");
            for (int j = 0; j < map.length; j++) {
                if (map[i][j] == Cross.NONE){
                    String tmp = "┼-";
                    if (i == 0) tmp = "┬-";
                    if (i == width) tmp = "┴-";
                    if (j == 0) tmp = "├-";
                    if (j == width) tmp = "┤ ";

                    if (i == 0 && j == 0) tmp = "┌-";
                    if (i == 0 && j == width) tmp = "┐";
                    if (i == width && j == 0) tmp = "└-";
                    if (i == width && j == width) tmp = "┘";

                    System.out.print(tmp);
                } else if (map[i][j] == Cross.BLACK){
                    System.out.print("● ");
                } else {
                    System.out.print("○ ");
                }
            }
            System.out.println();
        }
        System.out.print((now == Cross.BLACK ? " [ ● ] " : " [ ○ ] ") + " : ");
    }
}

