package top.dreamcenter.go.server;

import top.dreamcenter.go.msg.Cross;
import top.dreamcenter.go.msg.NewClick;

import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicBoolean;

public class UserThread extends Thread{

    private Socket socket;

    private ObjectOutputStream os;
    private ObjectInput oi;

    private Cross[][] map;

    private AtomicBoolean cur;
    private Cross self;

    private List<UserThread> users;

    public boolean isAlive;


    public UserThread(Socket socket, Cross[][] map, AtomicBoolean cur, Cross self, List<UserThread> list) {
        this.socket = socket;
        try {
            os = new ObjectOutputStream(socket.getOutputStream());
            oi = new ObjectInputStream(socket.getInputStream());
        } catch (IOException e) {
            e.printStackTrace();
        }
        this.map = map;
        this.cur = cur;
        this.self = self;
        users = list;
        isAlive = true;
    }

    @Override
    public void run() {
        try {
            sendMsg(self);
        } catch (IOException e) {
            e.printStackTrace();
        }

        // 不间断接收消息
        Thread thread = new Thread(() -> {
            while (true) {
                try {
                    Object o = recMsg();
                    NewClick newClick = (NewClick) o;

                    if (newClick.color == (cur.get() ? Cross.BLACK : Cross.WHITE) && newClick.color == self){
                        boolean result = CalDataUtil.draw(newClick, map);
                        if (result) {
                            cur.set(!cur.get());

                            users.forEach(u -> {
                                try {
                                    if (u.isAlive) u.sendMsg(DataUtil.parseData(map, newClick));
                                } catch (IOException e) {
                                    e.printStackTrace();
                                }
                            });
                        }
                    }
                } catch (Exception e){
                    System.out.println("::" + e.getMessage());
                    System.out.println("连接断开");
                    isAlive = false;
                    break;
                }
            }
        });
        thread.start();

        // 线程等待
        try {
            thread.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }

    public Socket getSocket() {
        return socket;
    }

    public void sendMsg(Object obj) throws IOException {
        os.writeObject(obj);
    }

    private Object recMsg() throws IOException, ClassNotFoundException {
        return oi.readObject();
    }
}
